# MFC Balance
[![Git release](https://img.shields.io/gitea/v/release/DrMaxNix/mfcbalance?gitea_url=https://git.tjdev.de&logo=git)](https://git.tjdev.de/DrMaxNix/mfcbalance/releases/latest)
[![F-Droid](https://img.shields.io/f-droid/v/de.drmaxnix.mfcbalance.svg?logo=fdroid)](https://f-droid.org/packages/de.drmaxnix.mfcbalance)
[![License](https://img.shields.io/badge/license-MIT-green)](https://git.tjdev.de/DrMaxNix/mfcbalance/src/branch/main/LICENSE)

Generic Reader for Balance on MIFARE Classic NFC Cards

![Android Screenshots](https://git.tjdev.de/DrMaxNix/mfcbalance/raw/branch/main/asset/screenshots-all-scaled.png "Android Screenshots")



## Installation
<a href="https://f-droid.org/packages/de.drmaxnix.mfcbalance/">
	<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png" alt="Get it on F-Droid" height="80">
</a>

Or

1. Download the latest APK from the [release section](https://git.tjdev.de/DrMaxNix/mfcbalance/releases/latest)
2. Run downloaded apk-file
3. You may get asked if you want to install this app from an unknown source



## FAQ
#### How can I find the correct settings values (eg. Sector Number)?
1. Get the [MIFARE Classic Tool](https://f-droid.org/en/packages/de.syss.MifareClassicTool/) app.
2. Using this app, read out your card and save it as a dump.
3. Now buy something using the card or recharge it with some money (do anything that changes your balance).
4. After that, create a second dump. Using _TOOLS > Diff Tool_, compare those two dumps.
5. If nothing changed at all, I'm sorry, but you cannot use this app with this card (there is just no way).
6. If something (maybe even a lot) changed on the card, you now have to fiddle around a bit. Convert you current balance (without any decimal points) to hexadecimal (eg. `34.87 -> 3487 -> 0D9F` or by swapping groups of two ("Little-Endian"): `9F0D`) and try to find that number within the areas that changed.
7. If you found a group of bytes that match your current balance, read off the position of this number (Sector, Block, etc.) within the MIFARE Classic Tool app. The _Byte Offset in Block_ is how many bytes ("groups of two") the number is from the left, starting at `0`. The _Number Size_ specifies how many bytes ("groups of two") the number is long.
8. Enter these values into the _Settings_ page of the **MFC Balance** app and try it out! If it doesn't work, or you get weird numbers, try using the _Debug Mode_ to see at which point the reading process is going south.

#### Where can I get the key to my card?
Depending on your country's legislation, cracking a key (or even just using a cracked key) could be illegal. That said, if you know your way around some tech stuffs, one could use tools like **Flipper Zero** or **Proxmark** to extract the key from an NFC card. There are enough tutorials online, so I won't be going into details here. There are also many lists of commonly used MIFARE Classic keys on the internet. You may try your luck with those first.

If the type of card you want to use the app with is used by a lot of people (possibly even some IT nerds), you could try asking around. At many places, the card keys are open secrets.



## Attribution / Credits
- Compose Preference ([Apache License 2.0](https://github.com/zhanghai/ComposePreference/blob/master/LICENSE)): https://github.com/zhanghai/ComposePreference
